/***************************************************************************
                          isdnctrl.h  -  description
                             -------------------
    begin                : Tue Mar 12 2002
    copyright            : (C) 2002 by Jrg Khler
    email                : joerg.k@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ISDNCTRL_H
#define ISDNCTRL_H
#ifdef HAVE_CONFIG_H
#define Str(x)	#x
#define Xstr(x)	Str(x)
#include <config.h>
#endif
#include <qwidget.h>
#include <qstring.h>
#include <qfile.h>
#include <qtimer.h>
#include <qdatetime.h>
#include <ksimpleconfig.h>
#include <qprocess.h>
//#include <kmessagebox.h>
#include "mymsgbox.h"
#include <kmessagebox.h>
/**controll ISDN
  *@author Jrg Khler
  */

class IsdnCtrl : public QWidget  {
   Q_OBJECT
public: 
	IsdnCtrl(QWidget *parent=0, const char *name=0);
	~IsdnCtrl();
	

void slot_start_process(bool);	// true fr dsl false fr i4l
	
private: // Private attributes
  /** receive Bytes (QString) */
  QString s1;
  /** receive Pakets (QString) */
  QString s2;
  /** transmitt Bytes (QString) */
  QString s3;
  /** transmitt Pakets (QString) */
  QString s4;
 /** connected or not */
  bool isConnect;
 /** 1sec Timer */
 QTimer * timer1;
private: // Private methods
  /** read proc/net/dev , reply s1, s2 , s3 ,s4 */
  void readDev();
  /** Initiatisierung Name of isdn device */
  void init();
  /** permission test */
  void access_test_isdninfo();
  /** No descriptions */
  void writeEndLog();
	void writeLog();



  /** ippp0 , ippp1  .... (QString) */
  QString device,pathIsdnctrl,pathIfconfig,pathTail;
  /** incomming outgoing bytes */
  double i_bytes,o_bytes;
  /* time session*/
  int time1,time2,time3;
  /** process read : cat /dev/isdndinfo */
  QProcess  * proc_cat;
  /**  */
  QProcess * proc_cat1;
  /** */
  QProcess * proc;
  QProcess * programm;
  /**  */
  QProcess * proc_ifconfig;
  /**  */
  QProcess * proc_if;
  /**  */
  bool chbundl;
public slots: // Public slots
  /** 1s timer  */
  void timer();
  /** start stop connections */
  void run_isdnctrl();
  /** Slot 
wird aufgerufen wenn neue Daten aus 
/dev/isdninfo gelesen werden
z.b. bei der Einwahl und Abwahl */
  void readISDNinfo(); //(KProcess *,char *, int);
  /** aktiviert Kanalbndelung */
  void slotChBundling(bool);
  /** read IP Adress and transmitt to infobox */
  void IPadress(); //(KProcess *,char *,int);
  /** No descriptions */
  void start_ifconfig();
  /** permission test */
  void access_test_isdnctrl(); //(KProcess*,char*,int);
  /** set Connect Time */
  void slotSetConnectTime(int,int,int);

	
void readPPPinfo(bool );

signals: // Signals
  /** Data to infobox  (Signal)
receive Byte, Pakets
transmitt Byte, Pakets 
Device and connectet or not */
  void update_signal(QString,QString,QString,QString,QString,bool);
  /** No descriptions */
  void update_tel_number(QString,QString,QString);
  /** No descriptions */
  void setConnect(QColor,bool);
  /** transmitt IP Adress to infobox */
  void update_ip_adress(QString,QString);
  /** logviev -> redraw logfile */
  void update_log();
  /** No descriptions */
  void update_load(double,double);
 void timer2();
};

#endif
