/***************************************************************************
                          kisdndial.cpp  -  description
                             -------------------
    begin                : Fre Mr  2 16:16:36 GMT 2001
    copyright            : (C) 2001 by Jrg Khler
    email                : joerg.k@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kisdndial.h"
#include <kiconloader.h>

extern "C"
{
  KPanelApplet* init( QWidget *parent, const QString configFile)
  {
    KGlobal::locale()->insertCatalogue("Kisdndial");
    return new Kisdndial(configFile, KPanelApplet::Stretch,
                      KPanelApplet::About | KPanelApplet::Help | KPanelApplet::Preferences,
                      parent, "kisdndial");
  }
}

Kisdndial::Kisdndial(const QString& configFile, Type type, int actions, QWidget *parent, const char *name)
       : KPanelApplet(configFile, type , actions , parent, name)
{
const QString Version = "016";
  firstRun();
   for  (int count =0; count< 100; count++)
   load_tmp[count]=0;
   iconApplet = new QLabel(this,0,0);

  loadIcons();
  initApplettOld();
  dlg = new dialog();    // new obj
  isdn = new IsdnCtrl();
  ibox = new infobox();          //new
  phoneNumber = new phone();  //new obj
  // QToolTip::add(iconApplet, i18n( "Kisdndial" ) );
  if ( sys_tem == DSL)
 p_status = new PPPStats();
  phoneNumber->start();


  data = new KAboutData("kisdndial","Kisdndial","0.1.6","Kisdndial - KDE ISDN and DSL Dialer",
                          KAboutData::License_GPL,"(c) 2001-2003 The Kisdndial Author",0, "http://www.kisdndial.de");
   data->addAuthor ("Joerg Koehler","Project Manager and Core Developer","joerg@kisdndial.de","http://www.kisdndial.de");

   connect(button_1, SIGNAL(clicked()),this,SLOT(info_box()));     //new
   connect(dlg,SIGNAL(update()),this,SLOT(new_color()));
   connect(isdn,SIGNAL(setConnect(QColor,bool)),this,SLOT(slotSetConnect(QColor,bool)));
//
// if (sys_tem== SMPPP) init_smppp();
 if ((sys_tem== ISDN4LINUX) || (sys_tem == DSL)) connect(button_2,SIGNAL(clicked()),isdn,SLOT(run_isdnctrl()));
//
   connect(isdn, SIGNAL(update_signal(QString,QString,QString,QString,QString,bool)),ibox,SLOT(update(QString,QString,QString,QString,QString,bool)));
   connect(isdn, SIGNAL(update_tel_number(QString,QString,QString)),ibox,SLOT(update_tel_number(QString,QString,QString)));
   connect(isdn, SIGNAL(update_ip_adress(QString,QString)),ibox,SLOT(update_ip(QString,QString)));
   connect(isdn, SIGNAL(update_tel_number(QString,QString,QString)),ibox,SLOT(update_tel_number(QString,QString,QString)));
   connect(isdn, SIGNAL(update_load(double,double)),this,SLOT(setLoad(double,double)));
   connect(ibox,SIGNAL(ChBundling(bool)),isdn,SLOT(slotChBundling(bool)));
   connect(isdn,SIGNAL(update_log()),ibox,SLOT(newDrawLog()));
  connect(ibox,SIGNAL(signalConnectTime(int,int,int)),isdn,SLOT(slotSetConnectTime(int,int,int)));
  connect(ibox,SIGNAL(signalConnectTime_1(int,int,int,int,int,int)),this,SLOT(slotShowTime(int,int,int,int,int,int)));
  connect(dlg,SIGNAL(switchApplet(bool)),this,SLOT(slotSwitchApplet(bool)));
  //connect(dlg,SIGNAL(update_dsl(bool)),isdn,SLOT(slot_start_process(bool)));

  if (sys_tem == DSL)
 	{
 	connect(isdn, SIGNAL(timer2()), p_status, SLOT(timerEvent()));  // 1s Timer
 	connect(p_status, SIGNAL(linkStat(bool)), isdn, SLOT(readPPPinfo(bool))); //return Status DSL
 	}
    KSimpleConfig conf("kisdndialrc");
   conf.setGroup("default");
   if (!(conf.readEntry("Version") == Version) || (!conf.hasKey("Version")))
    {conf.writeEntry("Version",Version);
    static MyMsgBox * wbox9;
     wbox9 = new MyMsgBox("9","Willkommen zu Kisndial 0.1.6 ",0,0);
     wbox9->show();
    }
}

Kisdndial::~Kisdndial()
{
 delete dlg;
 delete ibox;
 delete isdn;
 delete phoneNumber;
 if (sys_tem== DSL) delete p_status;
}

void Kisdndial::about()
{
 KAboutApplication *abApp = new KAboutApplication(data);
 abApp->show();
}
/*ruft die Hilfe auf******************************************/
void Kisdndial::help()
{
kapp->invokeHTMLHelp("kisdndial","");
}
/*ruft Einstellungsdialog auf******************************/
void Kisdndial::preferences()
{
  dlg->show();
}
/******************************************************/
int Kisdndial::widthForHeight( int ) const
{
return height() ;
}
/*wird aufgerufen beim verschieben des Applet , auerdem kann hier der Platzbedarf
des Applet bestimmt werden*/
int Kisdndial::heightForWidth( int ) const
{
return width();
}

void Kisdndial::initApplettOld(){
   KSimpleConfig conf("kisdndialrc");
  conf.setGroup("default");
  switch (conf.readNumEntry("system",1))
	{
	case 1:
	sys_tem= ISDN4LINUX;
	break;
	case 2:
	sys_tem= DSL;
	break;
	case 3:
	sys_tem= SMPPP;
	break;
	}
  button_1 = new QPushButton( this, "button_1" );
    button_1->setGeometry( 0, 0, 40, 13 ) ;
    QFont button_1_font(  button_1->font() );
    button_1_font.setFamily( "adobe-times" );
    button_1_font.setPointSize( 9 );
    button_1->setFont( button_1_font );
    if (sys_tem== ISDN4LINUX) button_1->setText( i18n( "ISDN" ) );
    if (sys_tem==  DSL) button_1->setText("eth");
//    QToolTip::add(  button_1, i18n( "Info" ) );

    button_2 = new QPushButton( this, "button_2" );
    button_2->setGeometry( 0, 14, 40, 13 ) ;
    QFont button_2_font(  button_2->font() );
    button_2_font.setFamily( "adobe-courier" );
    button_2_font.setPointSize( 9 );
    button_2->setFont( button_2_font );
    button_2->setText( i18n( "dial" ) );
    lcd_1 = new QLCDNumber( this, "lcd_1" );
    lcd_1->setGeometry(  0, 28, 40, 13 ) ;
    lcd_1->setFrameShape( QLCDNumber::Panel );
    lcd_1->setNumDigits( 3 );
    lcd_1->setSegmentStyle( QLCDNumber::Flat );
    QColor online(0,255,0);                                     //farben
color_online = conf.readColorEntry("color_online",&online);
conf.writeEntry("color_online",color_online);
QColor offline(255,0,0);
color_offline = conf.readColorEntry("color_offline",&offline);
conf.writeEntry("color_offline",color_offline);
  /**  */
// bool isConnect;
QColor lcd_tmp(0,0,0);
lcd_f = conf.readColorEntry("lcd_f",&lcd_tmp);
conf.writeEntry("lcd_f",lcd_f);
QColor lcd_tmp1(220,220,220);
lcd_r = conf.readColorEntry("lcd_r",&lcd_tmp1);
conf.writeEntry("lcd_r",lcd_r);
QColor button_1tmp(220,220,220);
button1_color = conf.readColorEntry("button1",&button_1tmp);
conf.writeEntry("button1",button1_color);            //farbeinstellung ende
switch (conf.readNumEntry("style")){
       case 0: lcd_1->setSegmentStyle( QLCDNumber::Outline );
               break;
       case 1: lcd_1->setSegmentStyle( QLCDNumber::Filled );
               break;
       case 2: lcd_1->setSegmentStyle( QLCDNumber::Flat );
               break;}
switch (conf.readNumEntry("shape")){
       case 0: lcd_1->setFrameShape( QLCDNumber::NoFrame );
               break;
       case 1: lcd_1->setFrameShape( QLCDNumber::Panel );
               break;
       case 2: lcd_1->setFrameShape( QLCDNumber::Box );
               break;
       case 3: lcd_1->setFrameShape( QLCDNumber::WinPanel );
               break;
       case 4: lcd_1->setFrameShape( QLCDNumber::StyledPanel );
               break;
       case 5: lcd_1->setFrameShape( QLCDNumber::PopupPanel );
               break;}
button_1->show();
button_2->show();
lcd_1->show();

this->resize(48,48);
if (!appNewOld)
	{
	button_1->hide();
	button_2->hide();
	lcd_1->hide();
	}
newStatus(); //set Color
}
/** show Infos */
void Kisdndial::info_box(){
// p_status->timerEvent();
ibox->show();
}

/** new color lcd button1 and button2
LCD style */
void Kisdndial::new_color(){
newStatus();
}

/** set new color or Dev
wechseln zwischen isdn4linux smppp oder dsl verb.*/
void Kisdndial::newStatus(){

KSimpleConfig conf("kisdndialrc");
conf.setGroup("default");
conf.sync();

//debug
printf("setcolor\n");
printf("conf%i  %i\n",conf.readNumEntry("system"),sys_tem);

if ((conf.readNumEntry("system")) != sys_tem)
{
if (conf.readNumEntry("system") == 1)
{
	if (sys_tem == DSL) //wechsel von DSL
		{delete p_status;
		printf("wechsel von DSL over Ethernet zu isdn4linux\n");
		}
sys_tem = ISDN4LINUX;
connect(button_2,SIGNAL(clicked()),isdn,SLOT(run_isdnctrl()));
isdn->slot_start_process(false);
}
//
if ((conf.readNumEntry("system") == 2))
{// Wechsel zu DSL
	if (sys_tem == ISDN4LINUX) // wechsel von ISDN4LINUX
		{p_status = new PPPStats();
		connect(p_status, SIGNAL(linkStat(bool)), isdn, SLOT(readPPPinfo(bool)));
		printf("wechsel von isdn4linux zu DSL over Ethernet \n");
		isdn->slot_start_process(true);
		}

sys_tem = DSL;
}

}
appNewOld = conf.readBoolEntry("classic");
color_online = conf.readColorEntry("color_online");
color_offline = conf.readColorEntry("color_offline");
button1_color = conf.readColorEntry("button1");
lcd_f = conf.readColorEntry("lcd_f");
lcd_r = conf.readColorEntry("lcd_r");
switch (conf.readNumEntry("style")){
       case 0: lcd_1->setSegmentStyle( QLCDNumber::Outline );
               break;
       case 1: lcd_1->setSegmentStyle( QLCDNumber::Filled );
               break;
       case 2: lcd_1->setSegmentStyle( QLCDNumber::Flat );
               break;}
switch (conf.readNumEntry("shape")){
       case 0: lcd_1->setFrameShape( QLCDNumber::NoFrame );
               break;
       case 1: lcd_1->setFrameShape( QLCDNumber::Panel );
               break;
       case 2: lcd_1->setFrameShape( QLCDNumber::Box );
               break;
       case 3: lcd_1->setFrameShape( QLCDNumber::WinPanel );
               break;
       case 4: lcd_1->setFrameShape( QLCDNumber::StyledPanel );
               break;
       case 5: lcd_1->setFrameShape( QLCDNumber::PopupPanel );
               break;}
QColorGroup g(lcd_f, lcd_r ,lcd_f , gray , black , blue, white);
  QPalette p(g,g,g);
  lcd_1->setPalette(p);
QColorGroup g2(darkGreen, button1_color ,button1_color , gray , black , black, white);
  QPalette p1(g2,g2,g2);
  button_1->setPalette(p1);


if (!conf.readBoolEntry("dsl"))
{

 button_1->setText(conf.readEntry("device"));
}
else
{
if (conf.readBoolEntry("LoadOnlyEth0")) button_1->setText("eth");
else button_1->setText("DSL");

}

button_1->repaint();
button_2->repaint();
lcd_1->repaint();

newsize();

}
/** set Connect and new Colors */
void Kisdndial::slotSetConnect(QColor colOnline ,bool connect){
KSimpleConfig conf("kisdndialrc");
conf.setGroup("default");

isConnect = connect;
color_online=colOnline;
QColorGroup g(green, color_online ,color_online , darkRed , black , darkBlue, white);
 QPalette p(g,g,g);
 if (appNewOld)
	{
	button_2->setPalette(p);
	if (isConnect){
	if (!conf.readBoolEntry("dsl"))
	button_1->setText(conf.readEntry("device"));
	else
	{
	if (conf.readBoolEntry("LoadOnlyEth0")) button_1->setText("eth");
	else button_1->setText("DSL");
	}
	button_2->setText("disc.");
	}
	else{
	if (!conf.readBoolEntry("dsl"))
	button_1->setText(conf.readEntry("device"));
	else
	{
	if (conf.readBoolEntry("LoadOnlyEth0")) button_1->setText("eth");
	else button_1->setText("DSL");
	}
	button_2->setText("dial");
	}
	}
}
/** No descriptions */
void Kisdndial::setLoad(double tmp ,double tmp_1){
KSimpleConfig conf("kisdndialrc");
conf.setGroup("default");
if (appNewOld){
 tmp += tmp_1;
 if (tmp >10)  lcd_1->setNumDigits( 4 );// ber 10 kb p sec 4 Stellen im lcd
 else  lcd_1->setNumDigits( 3 );
 lcd_1->display(tmp);}
 else{
  if ((tmp < 0.5) && (tmp_1 < 0.5) && (isConnect))
  iconApplet->setPixmap(ico2);
  if ((tmp < 0.5) && (tmp_1 < 0.5) && (!isConnect))
  iconApplet->setPixmap(ico1);
  if ((tmp >= 0.5) && (tmp_1 < 0.5))
  iconApplet->setPixmap(ico3);
  if ((tmp < 0.5) && (tmp_1 >= 0.5))
  iconApplet->setPixmap(ico4);
  if ((tmp >= 0.5) && (tmp_1 >= 0.5))
  iconApplet->setPixmap(ico5);
  iconApplet->repaint();
  tmp += tmp_1;
 }
if (conf.readBoolEntry("loadmeter"))
  draw_loadmeter(tmp);
}
/** No descriptions */
void Kisdndial::draw_loadmeter(double tmp){
KSimpleConfig conf("kisdndialrc");
conf.setGroup("default");
 for (int count=conf.readNumEntry("load_len",42)-2;count>0;count--)  //lnge des loadmeters
  { load_tmp[count] = load_tmp[count-1]; //verschieben
    load_tmp[0] = tmp;
  }
paint_loadmeter();
}
/** No descriptions */
void Kisdndial::paint_loadmeter(){
KSimpleConfig conf("kisdndialrc");
conf.setGroup("default");
int pos1,pos2;//count;
double  maxLoad = 8; // Loadmeteranzeige volle Hhe minimal 8 KB pro sec. ber 8kb automatische Anpassung der Hhe
 for (int count=conf.readNumEntry("load_len",42);count>0;count--)  //lnge des loadmeters
  { if (load_tmp[count] > maxLoad) maxLoad = load_tmp[count];

  }
if (orientation()==Horizontal)
 {pos1 =height() ; pos2=0;}
 else  {pos1 = 0; pos2=42;}                    //-42
 if (conf.readBoolEntry("loadmeter"))
 {
 for (int count=conf.readNumEntry("load_len",42);count>0;count--)  //lnge des loadmeters
  {
  QPainter p(this);
  p.setPen(conf.readColorEntry("load_color_foreground"));
  int pos_4 = (int) (pos2+height()-((height()/maxLoad)*load_tmp[count]));
  p.drawLine(pos1+count,pos2+height(),pos1+count,pos_4); //p.drawLine(pos1+count,pos2+height(),pos1+count,pos2+height()-((height()/maxLoad)*load_tmp[count]));
  p.end();
  QPainter p1(this);
  if (conf.readBoolEntry("load_color_auto")){
  if (isConnect) p1.setPen(color_offline);
  else p1.setPen(color_online);}
 else p1.setPen(conf.readColorEntry("load_color_background"));
pos_4 = (int) (pos2+height()-((height()/maxLoad)*load_tmp[count]));
p1.drawLine(pos1+count,pos_4,pos1+count,pos2+0);
   p1.end();
  }
 }
}
/** No descriptions */
void Kisdndial::paintEvent(QPaintEvent *){
paint_loadmeter();
}
/** No descriptions */
void Kisdndial::resizeEvent(QResizeEvent*){
 newsize();
}
 void Kisdndial::mousePressEvent(QMouseEvent *e){
  KSimpleConfig conf("kisdndialrc");
  conf.setGroup("default");
  QString smp_pr_dev;
  //linke Maustaste wirkt wie der dial Button aber nur im icon Modus
  if (e->button() == LeftButton &&(!appNewOld) && conf.readBoolEntry("LeftMouse"))
   {
   if (sys_tem == ISDN4LINUX || sys_tem == DSL) isdn->run_isdnctrl();
   }
   // Contex Menue auf rechter Moustaste
 if (e->button() == RightButton){

  QPixmap kisdndialIcon = SmallIcon(QString::fromLatin1("kisdndial"));
  QPixmap confIcon = SmallIcon(QString::fromLatin1("configure"));
  QPixmap helpIcon = SmallIcon(QString::fromLatin1("help"));
  QPixmap aboutIcon = SmallIcon(QString::fromLatin1("about_kde"));
  QPixmap exitIcon = SmallIcon(QString::fromLatin1("exit"));
  QPixmap infoIcon = SmallIcon(QString::fromLatin1("info"));
  QPixmap logIcon = SmallIcon(QString::fromLatin1("toggle_log"));
 if (sys_tem == ISDN4LINUX)
	{
	dev = new KPopupMenu();
	dev->clear();
	dev->insertTitle(i18n(" ISDN Device"));
	dev->insertItem(i18n(" ISDN automatic"),9);
	dev->insertItem(i18n("ippp0 ("+conf.readEntry("name1")+")"),0);
	dev->insertItem(i18n("ippp1 ("+conf.readEntry("name2")+")"),1);
	dev->insertItem(i18n("ippp2 ("+conf.readEntry("name3")+")"),2);
	dev->insertItem(i18n("ippp3 ("+conf.readEntry("name4")+")"),3);
	dev->insertItem(i18n("ippp4 ("+conf.readEntry("name5")+")"),4);
	dev->insertItem(i18n("ippp5 ("+conf.readEntry("name6")+")"),5);
	dev->insertItem(i18n("ippp6 ("+conf.readEntry("name7")+")"),6);
	dev->insertItem(i18n("ippp7 ("+conf.readEntry("name8")+")"),7);
	dev->insertItem(i18n("ippp8 ("+conf.readEntry("name9")+")"),8);
	}

if (sys_tem == DSL)
	{
	dev = new KPopupMenu();
	dev->clear();
	dev->insertTitle(i18n(" DSL over Ethernet"));
	dev->insertItem(i18n("DSL"),10);
	}

  menu = new KPopupMenu();
  menu->insertTitle(kisdndialIcon,"Kisdndial");
  menu->insertSeparator();
 // menu->insertItem(exitIcon,i18n("Quit"),this,SLOT(exit()));
 
  menu->insertSeparator();
 if (sys_tem == ISDN4LINUX)
{
	if (!conf.readBoolEntry("dsl"))
	{
		if (conf.readBoolEntry("auto"))
		dev->setItemChecked(9,true);
		if (conf.readEntry("device")=="ippp0")
		{dev->setItemChecked(0,true);
		menu->insertItem("ippp0("+conf.readEntry("name1")+")");}
		if (conf.readEntry("device")=="ippp1")
		{dev->setItemChecked(1,true);
		menu->insertItem("ippp1("+conf.readEntry("name2")+")");}
		if (conf.readEntry("device")=="ippp2")
		{dev->setItemChecked(2,true);
		menu->insertItem("ippp2("+conf.readEntry("name3")+")");}
		if (conf.readEntry("device")=="ippp3")
		{dev->setItemChecked(3,true);
		menu->insertItem("ippp3("+conf.readEntry("name4")+")");}
		if (conf.readEntry("device")=="ippp4")
		{dev->setItemChecked(4,true);
		menu->insertItem("ippp4("+conf.readEntry("name5")+")");}
		if (conf.readEntry("device")=="ippp5")
		{dev->setItemChecked(5,true);
		menu->insertItem("ippp5("+conf.readEntry("name6")+")");}
		if (conf.readEntry("device")=="ippp6")
		{dev->setItemChecked(6,true);
		menu->insertItem("ippp6("+conf.readEntry("name7")+")");}
		if (conf.readEntry("device")=="ippp7")
		{dev->setItemChecked(7,true);
		menu->insertItem("ippp7("+conf.readEntry("name8")+")");}
		if (conf.readEntry("device")=="ippp8")
		{dev->setItemChecked(8,true);
		menu->insertItem("ippp8("+conf.readEntry("name9")+")");}
	}
	else dev->setItemChecked(10,true);

	connect(dev,SIGNAL(activated(int)),dlg,SLOT(slotSetDev(int)));
}

if (sys_tem == DSL)
	{menu->insertItem(i18n("Connect/Disconnect"),isdn,SLOT(run_isdnctrl()));
	}

 if ( sys_tem ==  ISDN4LINUX)
	{
	menu->insertItem(i18n("Connect/Disconnect"),isdn,SLOT(run_isdnctrl()));
	menu->insertItem(i18n("DSL / ISDN Device"),dev);
	}

  menu->insertItem(infoIcon,i18n("Info"),this,SLOT(info_box()));
  menu->insertItem(logIcon,i18n("Log"),ibox,SLOT(viewLog()));
  menu->insertSeparator();
  menu->insertItem(aboutIcon,i18n("About"),this,SLOT(menuAbout()));
  menu->insertItem(helpIcon,i18n("Help"),this,SLOT(menuHelp()));
  menu->insertSeparator();
  menu->insertItem(confIcon,i18n("Preferences..."),this,SLOT(menuPreference()));
  menu->exec(e->globalPos());
if (sys_tem == ISDN4LINUX) delete dev;
 delete menu;
 }
 }

void Kisdndial::menuAbout(){
about();
}

void Kisdndial::menuHelp(){
help();
}

void Kisdndial::menuPreference(){
dlg->show();
}

void Kisdndial::exit(){
delete this;
}

void Kisdndial::firstRun(){
   KSimpleConfig conf("kisdndialrc");
   conf.setGroup("default");
 appNewOld = conf.readBoolEntry("classic",true); //true classic applet false = Icon
 conf.writeEntry("classic",appNewOld);
 bool  dsl = conf.readBoolEntry("dsl",false);
 conf.writeEntry("dsl",dsl);
 for (int count=1 ;count<11;count++)         //init 1
 {                                          // init1
 QString tmp1;                              //init1
 tmp1 = QString::number(count);             //init1
 int time = conf.readNumEntry("time_sec"+tmp1,0); //init1
 conf.writeEntry("time_sec"+tmp1 , time);        //lege 10 Zeitzhler !
 time = conf.readNumEntry("time_min"+tmp1,0);    //an dev ippp0 -ippp9
 conf.writeEntry("time_min"+tmp1 , time);        //min sec und hour
 time = conf.readNumEntry("time_hour"+tmp1,0);   //
 conf.writeEntry("time_hour"+tmp1 , time);      //init 1
 }
 QString name,temp;
bool isDisplayID = conf.readBoolEntry("display_id",TRUE);      // zeige
conf.writeEntry("display_id",isDisplayID);                //anrufer
temp = conf.readEntry("isdnctrl",Xstr (ISDNCTRL)); //Path config.h
conf.writeEntry("isdnctrl",temp);                   //pfade
temp = conf.readEntry("ifconfig", Xstr (IFCONFIG));  //pfade
conf.writeEntry("ifconfig",temp);                 //pfade
temp = conf.readEntry("tail", Xstr (TAIL));           //pfade
conf.writeEntry("tail",temp);                    //pfade
temp = conf.readEntry("pppd",Xstr (PPPD));
conf.writeEntry("pppd",temp);
temp = conf.readEntry("killall",Xstr (KILLALL));
conf.writeEntry("killall",temp);
name = conf.readEntry("name1","name");             //namen ippp0
conf.writeEntry("name1",name);
name = conf.readEntry("name2","name");
conf.writeEntry("name2",name);
name = conf.readEntry("name3","name");
conf.writeEntry("name3",name);
name = conf.readEntry("name4","name");
conf.writeEntry("name4",name);
name = conf.readEntry("name5","name");
conf.writeEntry("name5",name);
name = conf.readEntry("name6","name");
conf.writeEntry("name6",name);
name = conf.readEntry("name7","name");
conf.writeEntry("name7",name);
name = conf.readEntry("name8","name");
conf.writeEntry("name8",name);
name = conf.readEntry("name9","name");          //bis ippp8
conf.writeEntry("name9",name);
name = conf.readEntry("name10","name");          //bis ippp8
conf.writeEntry("name10",name);
QColor online(0,255,0);
color_online = conf.readColorEntry("color_online",&online);
conf.writeEntry("color_online",color_online);
QColor offline(255,0,0);
color_offline = conf.readColorEntry("color_offline",&offline);
conf.writeEntry("color_offline",color_offline);
QColor lcd_tmp(0,0,0);
lcd_f = conf.readColorEntry("lcd_f",&lcd_tmp);
conf.writeEntry("lcd_f",lcd_f);
QColor lcd_tmp1(220,220,220);
lcd_r = conf.readColorEntry("lcd_r",&lcd_tmp1);
conf.writeEntry("lcd_r",lcd_r);
QColor button_1tmp(220,220,220);
button1_color = conf.readColorEntry("button1",&button_1tmp);
conf.writeEntry("button1",button1_color);
temp = conf.readEntry("device","ippp0");
conf.writeEntry("device",temp);
bool temp1;
temp1 = conf.readBoolEntry("auto",false);
conf.writeEntry("auto",temp1);
temp1 = conf.readBoolEntry("classic",true);
conf.writeEntry("classic",temp1);
 KStandardDirs t;
QString dir = t.findResource("data","kisdndial/");
temp = conf.readEntry("iconname",dir+"isdn.png");
 conf.writeEntry("iconname",temp);
conf.sync();
}


void Kisdndial::newsize(){
if (appNewOld){
int h;
if  (orientation() == Horizontal)
{
if (height() < 23)
   {button_1->hide();
    lcd_1->hide();
    button_2->setGeometry(0, 0, 40, height());
    button_2->update();
   }
  if ((height() >= 23) && (height() < 32))
   {lcd_1->hide();
    button_1->setGeometry(0, 0, height(), (height()/2)-2 );
    button_2->setGeometry(0, ((height()/2)+1), height(), height()-5 );
    button_1->show();
    button_1->update();
    button_2->update();
   }
  if ((height() > 32) && (height() < 60))
   {h = (height()/3) -1;
    button_1->setGeometry( 0, 0, height(), h-1 ) ;
    button_2->setGeometry( 0, h , height(), h-1 );
    lcd_1->setGeometry(  0, h*2 , height(), h-1 ) ;
    button_1->show();
    lcd_1->show();
    button_1->update();
    button_2->update();
    lcd_1->update();
    }
   if(height() >= 60)
   {h = (height()/3) -3;
    button_1->setGeometry( 0, 0, height(), h-1 ) ;
    button_2->setGeometry( 0, h, height(), h-1 );
    lcd_1->setGeometry(  0, h*2, height(), h-1 ) ;
    button_1->show();
    lcd_1->show();
    button_1->update();
    button_2->update();
    lcd_1->update();
    }
 }
 else
 {
  if (width() < 25)
   lcd_1->hide();
  else
   lcd_1->show();
  button_1->show();
  button_2->show();
  button_1->setGeometry( 0, 0, width(), 13 ) ;
  button_2->setGeometry( 0, 14, width(), 13 );
  lcd_1->setGeometry(  0, 28, width(), 13 ) ;
  button_1->update();
  button_2->update();
  lcd_1->update();
  }
 }
else{  //show icon
loadIcons();
if (orientation() == Horizontal) iconApplet->setGeometry(0,0,height(),height());
else iconApplet->setGeometry(0,0,width(),width());
iconApplet->repaint();
}
}
/** No descriptions */
void Kisdndial::loadIcons(){
 KSimpleConfig conf("kisdndialrc");
 conf.setGroup("default");
 QString file ,filetmp;
 file = conf.readEntry("iconname");
  filetmp = file.right(4);
  file.remove((file.length()-4),4);
  if (file.endsWith("_22")) file.remove((file.length()-3),3);
  if ((file.endsWith("0")) || (file.endsWith("1")) || (file.endsWith("2")) || (file.endsWith("3"))
   || (file.endsWith("4")) || (file.endsWith("5")) || (file.endsWith("6")) || (file.endsWith("7"))
   || (file.endsWith("8")) || (file.endsWith("9")))
  file.remove((file.length()-1),1);
  if ((orientation() == Horizontal) && (height() > 40) || (orientation() == Vertical &&  width() >40))
  {
  ico1.load(file + filetmp);
  ico2.load(file + "1" + filetmp);
  ico3.load(file + "2" + filetmp);
  ico4.load(file + "3" + filetmp);
  ico5.load(file + "4" + filetmp);}
  else{
  ico1.load(file + "_22"+filetmp);
  ico2.load(file + "1_22" + filetmp);
  ico3.load(file + "2_22" + filetmp);
  ico4.load(file + "3_22" + filetmp);
  ico5.load(file + "4_22" + filetmp);}

   if  (orientation() == Horizontal)
   iconApplet->setGeometry(0,0,height(),height());
  iconApplet->show();
   if (appNewOld) iconApplet->hide();
 }
// /** No descriptions */
 void Kisdndial::slotSwitchApplet(bool classic){
if (classic) {
iconApplet->hide();
button_1->show();
button_2->show();
lcd_1->show();
appNewOld = true;}
else{
button_1->hide();
button_2->hide();
lcd_1->hide();
iconApplet->show();
appNewOld = false;
  }
}
// zeige Zeit im Button 1 anstatt nur das benutzte gert
void Kisdndial::slotShowTime(int ses1, int ses2, int ses3 ,int time1 ,int time2 , int time3)
{
KSimpleConfig conf("kisdndialrc");
 conf.setGroup("default");
 if (conf.readBoolEntry("Time_button"))
 {
	QString tmp_time,tmp1;
	if (conf.readBoolEntry("Time_button_total"))
			{ // toal time
			tmp_time = tmp1.setNum(time3,10) +":"+ tmp1.setNum(time2,10)+":"+ tmp1.setNum(time1,10);
			}
		else
			{ // session time
			tmp_time = tmp1.setNum(ses3,10) +":"+ tmp1.setNum(ses2,10)+":"+ tmp1.setNum(ses1,10);
			}
	button_1->setText(tmp_time);
}
}









