/***************************************************************************
                          logview.cpp  -  description
                             -------------------
    begin                : Mon Dec 10 2001
    copyright            : (C) 2001 by Jrg Khler
    email                : joerg.k@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "logview.h"
#include <qtooltip.h>

logView::logView(QWidget *parent, const char *name ) : logViewDlg(parent,name) {
lv->setSorting(-1,true);
KComboBox1->setSizeLimit(13);
KComboBox2->setSizeLimit(13);
 connect (Close , SIGNAL(clicked()) , this , SLOT(slotClose()));
 connect (KComboBox1 ,SIGNAL(activated(int)), this , SLOT(slotNewMonth(int)));
 connect (KComboBox2 ,SIGNAL(activated(int)), this , SLOT(slotNewDevice(int)));
 QDate Datum = QDate::currentDate();
 monat = Datum.month();
 connect (this,SIGNAL(initMonth(int)),this,SLOT(slotNewMonth(int)));
 emit initMonth(monat-1);
 KComboBox1->setCurrentItem(monat-1);
 emit initMonth(monat-1);
}
logView::~logView(){
}
/** No descriptions */
void logView::slotClose(){
this->hide();
}
/** No descriptions */
void logView::slotNewMonth(int month){
lv->clear();
KSimpleConfig log("kisdndiallog");
switch (month){
       case 0:if (log.hasGroup("1")) log.setGroup("1");
              else noData();
              break;
       case 1:if (log.hasGroup("2")) log.setGroup("2");
              else noData();
              break;
       case 2:if (log.hasGroup("3")) log.setGroup("3");
              else noData();
              break;
       case 3:if (log.hasGroup("4")) log.setGroup("4");
              else noData();
              break;
       case 4:if (log.hasGroup("5")) log.setGroup("5");
              else noData();
              break;
       case 5:if (log.hasGroup("6")) log.setGroup("6");
              else noData();
              break;
       case 6:if (log.hasGroup("7")) log.setGroup("7");
              else noData();
              break;
       case 7:if (log.hasGroup("8")) log.setGroup("8");
              else noData();
              break;
       case 8:if (log.hasGroup("9")) log.setGroup("9");
              else noData();
              break;
       case 9:if (log.hasGroup("10")) log.setGroup("10");
              else noData();
              break;
       case 10:if (log.hasGroup("11")) log.setGroup("11");
              else noData();
              break;
       case 11:if (log.hasGroup("12")) log.setGroup("12");
              else noData();
              break;
       }
QListViewItem * item = new QListViewItem(lv);
QString tmp,tmp1,temp1,day,from,dev,byte_in_1,byte_out_1,until,byte_in_2,byte_out_2,time_sec,time_min,time_hour;
unsigned long int byte_in,byte_out,byte_ges_in,byte_ges_out;

byte_ges_in = 0;
byte_ges_out = 0;
int time_ges_sec=0;
int time_ges_min=0;
int time_ges_hour=0;
for (int count=1; count < (log.readNumEntry("lognum",0))+1 ; count++)
{

 tmp = log.readEntry(tmp1.setNum(count,10)+"begin");
 day=tmp.left(tmp.find(";"));  //Date
 tmp.remove(0,(1+tmp.find(";"))); //remove Date
 from=tmp.left(tmp.find(";")); //time
 tmp.remove(0,(1+tmp.find(";")));//remove Time
 dev=tmp.left(tmp.find(";")); //Device
 tmp.remove(0,(1+tmp.find(";")));//remove Device
 byte_in_1=tmp.left(tmp.find(";"));//bytes in
 tmp.remove(0,(1+tmp.find(";")));//remove bytes in
 byte_out_1=tmp; // bytes out

 tmp= log.readEntry(tmp1.setNum(count,10)+"end");
 until=tmp.left(tmp.find(";")); //time end connection
 tmp.remove(0,(1+tmp.find(";"))); //remove time
 byte_in_2=tmp.left(tmp.find(";")); //bytes in
 tmp.remove(0,(1+tmp.find(";"))); //remove bytes in
 byte_out_2=tmp.left(tmp.find(";")); //bytes out
 tmp.remove(0,(1+tmp.find(";"))); //remove bytes out
 time_sec=tmp.left(tmp.find(";")); //connecttime sec.
 tmp.remove(0,(1+tmp.find(";"))); //remove sec
 time_min=tmp.left(tmp.find(";")); //connecttime min
 tmp.remove(0,(1+tmp.find(";"))); //remove min
 time_hour=tmp; //connecttime hour

 if ((KComboBox2->currentItem()==0) ||
    ((KComboBox2->currentItem()==1)&&( dev=="ppp0")) ||
    ((KComboBox2->currentItem()==2)&&( dev=="ippp0")) ||
    ((KComboBox2->currentItem()==3)&&( dev=="ippp1")) ||
    ((KComboBox2->currentItem()==4)&&( dev=="ippp2")) ||
    ((KComboBox2->currentItem()==5)&&( dev=="ippp3")) ||
    ((KComboBox2->currentItem()==6)&&( dev=="ippp4")) ||
    ((KComboBox2->currentItem()==7)&&( dev=="ippp5")) ||
    ((KComboBox2->currentItem()==8)&&( dev=="ippp6")) ||
    ((KComboBox2->currentItem()==9)&&( dev=="ippp7")) ||
    ((KComboBox2->currentItem()==10)&&( dev=="ippp8")) ||
    ((KComboBox2->currentItem()==11)&&( dev=="ippp9"))
    )
 {item = new QListViewItem( lv, item );
  item->setText(0,day+"."+temp1.setNum(month+1,10)+".");//day+month
  item->setText(1,dev); //begin connect
  item->setText(2,from);  // device
  if ( (log.hasKey(tmp1.setNum(count,10)+"begin")) && (log.hasKey(tmp1.setNum(count,10)+"end")))
  {
  item->setText(3,until); //end connect
  item->setText(4,time_hour+":"+time_min+":"+time_sec); //connecttime
  // total time
    time_ges_sec += time_sec.toInt();
    if (time_ges_sec >= 60)
     { time_ges_sec = time_ges_sec -60;
       time_ges_min ++;}
    time_ges_min += time_min.toInt();
    if (time_ges_min >= 60)
     { time_ges_min = time_ges_min -60;
       time_ges_hour ++;}
    time_ges_hour += time_hour.toInt();

  byte_in= byte_in_2.toULong()-byte_in_1.toULong();  // berechne Bytes in und out
  byte_out= byte_out_2.toULong()-byte_out_1.toULong();
  if (byte_in >= 1024)
   {byte_in = byte_in / 1024;
    byte_ges_in += byte_in;
    item->setText(5,tmp1.setNum(byte_in,10)+" KB");
     }
  else item->setText(5,tmp1.setNum(byte_in,10)+" B");

  if (byte_out >= 1024)
   {byte_out = byte_out / 1024;
    byte_ges_out += byte_out;
    item->setText(6,tmp1.setNum(byte_out,10)+" KB");
   }
  else item->setText(6,tmp1.setNum(byte_out,10)+" B");

  } //end if log.haskey ...
  else {item->setText(3," Error ");// endkey not in memory
        item->setText(4," no ");
        item->setText(5," Data ");
        }
      } //end if device == key in the log
     }  // end for loop
 item = new QListViewItem( lv, item );
 item->setText(0,"total");
 item->setText(4,tmp1.setNum(time_ges_hour,10)+":"+tmp1.setNum(time_ges_min,10)+":"+tmp1.setNum(time_ges_sec,10));
 item->setText(5,tmp1.setNum(time_ges_hour,10)+":"+tmp1.setNum(time_ges_min,10)+":"+tmp1.setNum(time_ges_sec,10));
  if (byte_ges_in > 9999)         // total Bytes in
  { byte_ges_in = byte_ges_in / 1024;
    item->setText(5,tmp1.setNum(byte_ges_in,10)+" MB");
  }
  else item->setText(5,tmp1.setNum(byte_ges_in,10)+" KB");
  if (byte_ges_out > 9999)            //total bytes out
  { byte_ges_out = byte_ges_out / 1024;
    item->setText(6,tmp1.setNum(byte_ges_out,10)+" MB");
  }
  else item->setText(6,tmp1.setNum(byte_ges_out,10)+" KB");
  }

/** No descriptions */
void logView::noData(){
QListViewItem * item = new QListViewItem(lv);
item->setText(0, "No");
item->setText(1, "Data");
}
/** No descriptions */
void logView::slotNewDevice(int){
 emit initMonth(KComboBox1->currentItem());
}
/** refresh the Log Window */
void logView::reDrawLog(){
emit initMonth(monat-1);
}
