#include <klocale.h>
/****************************************************************************
                         mymsgbox.cpp  -  description
                             -------------------
    begin                : Wed Jan 8 16:16:36 GMT 2003
    copyright            : (C) 2001 by Jrg Khler
    email                : kisdndial@kisdndial.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
****************************************************************************/

#include "mymsgbox.h"
#include <qhbox.h>
#include <qvariant.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qcheckbox.h>
#include <kmessagebox.h>

/* 
 *  Constructs a MyMsgBox as a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f'.
   Message Telefon Nummer
 */
MyMsgBox::MyMsgBox(int idx, QString text1 , QString text2 , QWidget* parent, const char* name, WFlags fl )
    : QDialog( parent, name, fl )
{
     KSimpleConfig tel("kisdndialtel");
     tel.setGroup("default");
    indexMem= idx;
    if ( !name )
	setName( "MyMsgBox" );
    setMinimumSize( QSize( 200, 75 ) );
    MyMsgBoxLayout = new QGridLayout( this, 1, 1, 11, 6, "MyMsgBoxLayout"); 
    textLabel1 = new QLabel( this, "textLabel1" );
    textLabel1->setAlignment( int( QLabel::AlignCenter ) );
    MyMsgBoxLayout->addMultiCellWidget( textLabel1, 0, 0, 0, 4 );
    textLabel2 = new QLabel( this, "textLabel2" );
    textLabel2->setAlignment( int( QLabel::AlignCenter ) );
    MyMsgBoxLayout->addMultiCellWidget( textLabel2, 1, 1, 0, 4 );
    Button1 = new QPushButton( this, "Button1" );
    MyMsgBoxLayout->addWidget( Button1, 3, 2 );
    lineEdit1 = new QLineEdit( this, "lineEdit1" );
   MyMsgBoxLayout->addMultiCellWidget( lineEdit1, 2, 2, 1, 4 );
   Button2 = new QPushButton( this, "Button2" );
    MyMsgBoxLayout->addWidget( Button2, 3, 4 );
    QSpacerItem* spacer = new QSpacerItem( 71, 21, QSizePolicy::Expanding, QSizePolicy::Minimum );
    MyMsgBoxLayout->addItem( spacer, 3, 3 );
    QSpacerItem* spacer_2 = new QSpacerItem( 221, 21, QSizePolicy::Expanding, QSizePolicy::Minimum );
    MyMsgBoxLayout->addMultiCell( spacer_2, 3, 3, 0, 1 );
     text2.remove(text2.length()-1,1);
     textLabel1->setText( text1 );
     textLabel2->setText( text2);
    
     Button1->setText( tr2i18n( "Ok" ) );
     Button2->setText (tr2i18n( "Save") );
    resize( QSize(350, 170).expandedTo(minimumSizeHint()) );
    connect(Button1, SIGNAL(clicked()),this,SLOT(close())); 
    connect(Button2, SIGNAL(clicked()),this,SLOT(save())); 
    
   KSimpleConfig conf("kisdndialrc");
    conf.setGroup("default");
    timer = new QTimer( this );
    if (conf.readNumEntry("CallerID_time") >0) // Wenn Zeit = 0 dann Fenster nicht automatisch lschen
    { connect( timer, SIGNAL(timeout()),
             this, SLOT(closeShowID()) );
    timer->start( conf.readNumEntry("CallerID_time")*1000, TRUE );
     }
   QString tmp;
   if (text2.find("+") >=0) text2.remove(0,text2.find("+")+3);
   tmp = text2.simplifyWhiteSpace();
   text2 = tmp.stripWhiteSpace();
   if (text2.find(" ") >=0) text2.remove(text2.find(" "),1);
   if (tel.hasKey(text2)) lineEdit1->setText(tel.readEntry(text2));
   TelNumber = text2;
}

// Constructor  Message warning
MyMsgBox::MyMsgBox( QString idx , QString text1 , QString text2 , QWidget* parent, const char* name, WFlags fl )
    : QDialog( parent, name, fl )
{   index = idx;
   
	setName( "MyMsgBox" );
    setMinimumSize( QSize( 200, 75 ) );
    MyMsgBoxLayout = new QGridLayout( this, 1, 1, 11, 6, "MyMsgBoxLayout");
    textLabel1 = new QLabel( this, "textLabel1" );
    textLabel1->setAlignment( int( QLabel::AlignCenter ) );
    MyMsgBoxLayout->addMultiCellWidget( textLabel1, 0, 0, 0, 2 );
    textLabel2 = new QLabel( this, "textLabel2" );
    textLabel2->setAlignment( int( QLabel::AlignCenter ) );
    MyMsgBoxLayout->addMultiCellWidget( textLabel2, 1, 1, 0, 2 );
    QSpacerItem* spacer = new QSpacerItem( 243, 21, QSizePolicy::Expanding, QSizePolicy::Minimum );
    MyMsgBoxLayout->addItem( spacer, 3, 2 );
    Button3 = new QPushButton( this, "Button1" );
    MyMsgBoxLayout->addWidget( Button3, 3, 1 );
    QSpacerItem* spacer_2 = new QSpacerItem( 240, 21, QSizePolicy::Expanding, QSizePolicy::Minimum );
    MyMsgBoxLayout->addItem( spacer_2, 3, 0 );
    
    checkBox1 = new QCheckBox( this, "checkBox1" );
   Button3->setText( tr2i18n( "Ok" ) );
   textLabel1->setText( text1 );
   textLabel2->setText( text2);
    checkBox1->setText( tr2i18n( "don't show again" ) );
    MyMsgBoxLayout->addWidget( checkBox1, 2, 0 );
    connect(Button3, SIGNAL(clicked()),this,SLOT(closeWarning())); 
   resize( QSize(500, 162).expandedTo(minimumSizeHint()) );

}

// Password Dialog for smpppd

MyMsgBox::MyMsgBox(QWidget* parent, const char* name)
    : QDialog (parent, name, true)
{
   setCaption (i18n ("(Kisdndial) Password"));

    QVBoxLayout* vbox = new QVBoxLayout (this);
    vbox->setMargin (10);
    vbox->setSpacing (10);

    QLabel* label = new QLabel (i18n ("Enter the password for your "
				      "Internet provider:"), this);
    vbox->addWidget (label);

    password = new QLineEdit (this);
    vbox->addWidget (password);
    password->setText ("");
    password->setEchoMode (QLineEdit::Password);
    password->setFocus ();
    connect (password, SIGNAL (returnPressed ()), SLOT (accept ()));

    QHBox* hbox = new QHBox (this);
    vbox->addWidget (hbox);
    hbox->setSpacing (10);

    Button1 = new QPushButton (i18n ("Ok"), hbox);
    connect (Button1, SIGNAL (clicked ()), SLOT (accept ()));

    Button2 = new QPushButton (i18n ("Cancel"), hbox);
    connect (Button2, SIGNAL (clicked ()), SLOT (reject ()));
}


/*
 *  Destroys the object and frees any allocated resources
 */
MyMsgBox::~MyMsgBox()
{
    // no need to delete child widgets, Qt does it all for us
}



/**
Schliet das Fenster
*/
void MyMsgBox::close()
{ //this->hide();
 
  emit Exit(indexMem);
}

/**
Speichert Namen und Telefonnummer
*/
void MyMsgBox::save()
{ //this->hide();
KSimpleConfig tel("kisdndialtel");
tel.setGroup("default");

tel.writeEntry(TelNumber,lineEdit1->text());
   emit Exit(indexMem);
}

void MyMsgBox::closeWarning()
{  KSimpleConfig conf("kisdndialrc");
    conf.setGroup("default");
    //index == 9 Message new Version
  if (!(index == "9")) conf.writeEntry("warning"+index, checkBox1->isChecked());
this->hide();
 // emit Exit();
}

void MyMsgBox::closeShowID()
{ emit Exit(indexMem);
}

QString
MyMsgBox::get_password () const
{
    return password->text ();
}


